article/urls.py
from django.urls import path
from . import views

app_name = 'article'

urlpatterns = [
    # 文章详情
    path('article-detail/<int:id>/', views.article_detail, name='article_detail'),
    # 文章创建
    path('article-create/', views.article_create, name='article_create'),
    # 文章更新
    path('article-update/<int:id>/', views.article_update, name='article_update'),
    # 文章删除
    path('article-delete/<int:id>/', views.article_delete, name='article_delete'),
    # 文章附件下载
    path('article-download/<int:id>', views.download_file, name='download_file'),
]

blocks/urls.py
# 引入path
from django.urls import path
from . import views

# 正在部署的应用的名称
app_name = 'blocks'

urlpatterns = [
    path('blocks-list-friend/', views.blocks_list_friend, name='blocks_list_friend'),
    path('blocks-list-study/', views.blocks_list_study, name='blocks_list_study'),
    path('blocks-list-life/', views.blocks_list_life, name='blocks_list_life'),
]

like/urls.py
from django.urls import path
from . import views

app_name = 'like'

urlpatterns = [
    path('like-change/', views.like_change, name='like_change'),
]

notice/urls.py
from django.urls import path
from . import views

app_name = 'notice'
# 路由设置
urlpatterns = [
    # 通知列表
    path('list/', views.CommentNoticeListView.as_view(), name='list'),
    # 更新通知状态
    path('update/', views.CommentNoticeUpdateView.as_view(), name='update'),
]

question/urls.py
from django.urls import path
from . import views

app_name = 'question'

urlpatterns = [

    # 文章详情
    path('question-detail/<int:id>/', views.question_detail, name='question_detail'),
    path('question-create/', views.question_create, name='question_create'),
    path('question-update/<int:id>/', views.question_update, name='question_update'),
    path('question-delete/<int:id>/', views.question_delete, name='question_delete'),
    path('question-download/<int:id>', views.download_file, name='download_file'),
]

sailing/urls.py
from django.contrib import admin
from django.urls import path, include
from django.shortcuts import render
from article import views as article_views
from question import views as question_views
from userprofile import views as user_views

from django.conf import settings
from django.conf.urls.static import static
from itertools import chain
import notifications.urls
def mainPage(request):
    return render(request, 'userprofile/collection.html', {})

def sort_column(column_questions, column_articles):
    column_content = []

    for question in column_questions:
        content = {'title': question.title, 'id': question.id, 'column': str(question.column), 'updated': question.updated, 'type': 'question'}
        column_content.append(content)
        pass

    for article in column_articles:
        content = {'title': article.title, 'id': article.id, 'column': str(article.column), 'updated': article.updated, 'type': 'article'}
        column_content.append(content)
        pass

    column_content = sorted(column_content, key=lambda x:(x['column'], x['updated']), reverse = True)
    
    #for item in column_content:
    #    if item['column'] != 'None':
    #        print(item)
    return column_content

def hot_content(request):
    # hotContent
    hot_questions = question_views.hot_question_list(request)
    hot_articles = article_views.hot_article_list(request)
    # blockContent
    column_questions = question_views.column_question_list()
    column_articles = article_views.column_article_list()
    column_content = sort_column(column_questions["column_questions"], column_articles["column_articles"])
    column_content = {'column_content': column_content}

    context = {**hot_questions, **hot_articles, **column_content}
    return render(request, 'mainPage.html', context)

urlpatterns = [
    path('admin/', admin.site.urls),
    path('userprofile/', include('userprofile.urls', namespace='userprofile')),
    path('article/', include('article.urls', namespace='article')),
    path('question/', include('question.urls', namespace='question')),
    path('comment/', include('comment.urls', namespace='comment')),
    path('answer/', include('answer.urls', namespace='answer')),
    path('like/', include('like.urls', namespace='like')),
    path('', hot_content, name='hot_content'),
    path('collect/', include('collect.urls', namespace='collect')),
    path('search_question/', question_views.search_question),
    path('search_article/', article_views.search_article),
    path('search_user/', user_views.search_user),
    path('blocks/',include('blocks.urls', namespace='blocks')),
    path('inbox/notifications/', include(notifications.urls, namespace='notifications')),
    path('notice/', include('notice.urls', namespace='notice')),
    # path('', mainPage)
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

templates/back_to_top_func.html
<!-- 
片段名称： 回到顶部按钮
作者:     wzd
时间：     2020-8-9
功能：    点击按钮，从页面的任何位置回到顶部
修改记录： 
--> 
<button type="button" id="BackTop" class="toTop-arrow" style="z-index: 100;"></button>

<script>
    // 向上滚动的函数
    $(function () {
        $('#BackTop').click(function () {
            $('html,body').animate({scrollTop: 0}, 500);
        });
        $(window).scroll(function () {
            if ($(this).scrollTop() > 300) {
                $('#BackTop').fadeIn(300);
            } else {
                $('#BackTop').stop().fadeOut(300);
            }
        }).scroll();
    });
</script>

<style>
    /* 按钮边框的大小、位置、样式 */
    .toTop-arrow {
        width: 3.5rem;
        height: 3.5rem;
        padding: 0;
        margin: 0;
        border: 0;
        border-radius: 33%;
        opacity: 0.7;
        background: black;
        cursor: pointer;
        position: fixed;
        right: 1.5rem;
        bottom: 1.5rem;
        display: none;
    }

    /* 绘制按钮中的向上箭头 */
    .toTop-arrow::before, .toTop-arrow::after {
        width: 31px;
        height: 7px;
        border-radius: 3px;
        background: orange;
        position: absolute;
        content: "";
    }

    .toTop-arrow::before {
        transform: rotate(-45deg) translate(0, -50%);
        left: 0.4rem;
    }

    .toTop-arrow::after {
        transform: rotate(45deg) translate(0, -50%);
        right: 0.4rem;
    }

    /* 取消点击按钮时的聚焦 */
    .toTop-arrow:focus {
        outline: none;
    }
</style>

templates/base.html
<!-- 
片段名称： 页面模板
作者:     wzd
时间：     2020-8-5
功能：    所有页面以此为基本模板添加功能
修改记录： 
--> 

<!-- 载入静态文件 -->
<!-- 静态文件夹寻址需要在setting里部署！！！ -->
{% load staticfiles %}
<!DOCTYPE html>
<!-- 网站主语言 -->
<html lang="zh-cn">

<head>
    <!-- 网站采用的字符编码 -->
    <meta charset="utf-8">
    <!-- 预留网站标题的位置 -->
    <title>{% block title %}{% endblock %}</title>
    <!-- 引入bootstrap的css文件 -->
    <link rel="stylesheet" href="{% static 'bootstrap/css/bootstrap.min.css' %}">
    <link rel="stylesheet" href="{% static 'css/blockContent.css' %}">
    <link rel="stylesheet" href="{% static 'fontawesome/css/all.css' %}">
    
</head>

<body>
    <!-- 引入导航栏 -->
    {% include 'header.html' %}
    <!-- 预留具体页面的位置 -->
    <!-- 新增两个 div 容器 -->
    <div id="wrapper">
        {% block content %}{% endblock content %}
        <div id="push"></div>
    </div>
    <!-- 引入注脚 -->
    {% include 'footer.html' %}
    <!-- bootstrap.js 依赖 jquery.js 和popper.js，因此在这里引入 -->
    <script src="{% static 'jquery/jquery.js' %}"></script>

    <script src="{% static 'popper/popper.js' %}"></script>
    <!-- 引入bootstrap的js文件 -->
    <script src="{% static 'bootstrap/js/bootstrap.min.js' %}"></script>
    <!-- 引入layer.js弹窗功能 -->
    <script src="{% static 'layer/layer.js' %}"></script>
    <!-- 在jquery后面引入 -->
    {% include 'back_to_top_func.html' %}

    {% block script %}{% endblock script %}

<!-- 增加样式 -->
    <style>
        html, body {
            height: 100%;
            margin: 0;
        }

        #wrapper {
            min-height: 100%;
            margin-bottom: -60px;
        }

        #footer,
        #push {
            height: 60px;
        }
    </style>
</body>

</html>

templates/footer.html
{% load staticfiles %}
<!-- Footer -->
<div>
    <br><br><br>
</div>
<!-- 
片段名称： 脚注
作者:	    wzd
时间：	    2020-8-3
功能：	   显示脚注信息，始终在页面的最下面
修改记录： 
--> 
<footer class="py-3 bg-dark" id="footer">
    <div class="container">
        <p class="m-0 text-center text-white">Copyright &copy; 小青龙团队 </p>
    </div>
</footer>

templates/header.html
{% regroup column_content by column as content_list %}
{% load notifications_tags %}
{% notifications_unread as unread_count %}
<!-- 定义导航栏 ，黑色，固定在顶部-->
<nav class="navbar navbar-expand-lg navbar-dark bg-dark navbar-fixed-top">
  <div class="container-fluid">

    <!-- 同济堂 ，按钮点击可以返回主界面-->
    <div class="navbar-header">
      <a class="navbar-brand" href="/">同济堂</a>
<!-- 
片段名称：  进入三个板块界面的入口
作者:	    wzd qhy
时间：	    2020-8-7
功能：	   提供三个连接，可以分别进入 学习，生活，交友的板块列表
修改记录： 
--> 
          <!--板块1名称-->
          <span class="mt-2 ml-2"><i class="fas fa-graduation-cap" style="color:white; font-size:30px;"></i></span>
          <a class="navbar-brand" style="font-size:15px" href="{% url 'blocks:blocks_list_study'  %}">学习</a>

          <!--板块2名称-->
          <span class="mt-2 ml-2"><i class="far fa-calendar-alt" style="color:white; font-size:30px;"></i></span>
          <a class="navbar-brand" style="font-size:15px" href="{% url 'blocks:blocks_list_life'  %}">生活</a>


          <!--板块3名称-->
            <span class="mt-2 ml-2"><i class="fas fa-users" style="color:white; font-size:30px;"></i></span>
          <a class="navbar-brand" style="font-size:15px" href="{% url 'blocks:blocks_list_friend'  %}">交友</a>

    </div>
<!-- 
片段名称：  提供搜索模块
作者:	    ssc
时间：	    2020-8-7
功能：	   可以旋转进入问题，文章，用户搜索的界面
修改记录： 
--> 
    <ul class="nav navbar-nav navbar-right">
      <li class="nav-item dropdown">
        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" 
        role="button" data-toggle="dropdown" 
        aria-haspopup="true" aria-expanded="false"> 
        搜索</a>
          <!--如果有头像，会显示头像，没有头像，会显示用户名-->
      
      <div class="dropdown-menu" aria-labelledby="navbarDropdown">
        <a class="dropdown-item" href='/search_question'>问题搜索</a>
        <a class="dropdown-item" href="/search_article">文章搜索</a>
        <a class="dropdown-item" href="/search_user">用户搜索</a>
      </div>
  </li>

<!-- 
片段名称：  个人信息相关页面的入口
作者:	    ssc
时间：	    2020-8-7
功能：	   登入前和登入后有不同的显示，登入前提供跳转到登入的入口，登入后，提供进入我的收藏，
个人中心，通知等界面的的入口
修改记录： 
--> 
      {% if user.is_authenticated %}

      <a class="btn text-light" href="{% url 'userprofile:get_collect_record' user.id %}">我的收藏</a>
        <a class="btn text-light" href="{% url 'userprofile:user_get_myob' user.id %}">个人空间</a>
<!--<a class="btn text-light" href="https://www.runoob.com/html/html-links.html">{消息}</a>
      <a class="btn text-light" href="https://www.runoob.com/html/html-links.html">{动态}</a>-->
      {% endif %}
      <!-- Django的 if 模板语句 -->
      {% if user.is_authenticated %}
          <!-- 如果用户已经登录，则显示用户名下拉框 -->
          <li class="nav-item dropdown">
                <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                  <!-- 新增代码，小红点 -->
        {% if unread_count %}
            <svg viewBox="0 0 8 8"
                 width="8px"
                 height="8px">
                <circle cx="4"
                        cy="4"
                        r="4"
                        fill="#ff6b6b"
                        ></circle>
            </svg>
        {% endif %}
                  {% if globle_profile.avatar %}
                  <img src={{ globle_profile.avatar.url }} alt={{user.username}} style="width: 40px;height: 40px; border-radius:50%;" />
                  {% else %}
                  <img src="https://ss0.bdstatic.com/94oJfD_bAAcT8t7mm9GUKT-xh_/timg?image&quality=100&size=b4000_4000&sec=1592383038&di=3918b09a3244e0fa942873a932879bc8&src=http://pic.soutu123.cn/element_origin_min_pic/01/37/09/22573c3a831082c.jpg!/fw/700/quality/90/unsharp/true/compress/true" alt={{user.username}} style="width: 40px;height: 40px; border-radius:50%;" />
                  {% endif %}
                  <!--如果有头像，会显示头像，没有头像，会显示用户名-->
              </a>

              <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                  <a class="dropdown-item" href="{% url "notice:list" %}">通知
            {% if unread_count %}
            <span class="badge badge-danger">{{ unread_count }}</span>
            {% endif %}
        </a>
                <a class="dropdown-item" href='{% url "userprofile:profile" user.id %}'>个人信息</a>
                  <a class="dropdown-item" href='{% url "userprofile:logout" %}'>退出登录</a>
<!--                <a class="dropdown-item" href='{% url "userprofile:delete" user.id %}'>删除用户</a>-->
              </div>
          </li>
      <!-- 如果用户未登录，则显示 “登录” -->
      {% else %}
          <li class="nav-item">
              <a class="nav-link" href="{% url 'userprofile:login' %}">登录</a>
          </li>                    
      <!-- if 语句在这里结束 -->
      {% endif %}
    </ul>
  </div>
</nav>

templates/hotContent.html
<div class="text-center mt-4">
    <h4><b>热门问题</b></h4>
</div>
<!-- 
片段名称：  显示热门问题
作者:	    qhy
时间：	    2020-8-4
功能：	   显示热门问题，根据热度顺序显示，并根据会显示所属板块，点击可以浏览详情
修改记录： 
--> 
<!-- 列表循环 -->
<div class="row ml-5">
    {% for question in questions %}
        <!-- 文章内容 -->
        <div class="col-12">
            <!-- 栏目 -->
            {% if question.column %}
            <a href=
            {% if question.column.title == '生活' %}
                "/blocks/blocks-list-life/"
            {% elif question.column.title == '学习' %}
                "/blocks/blocks-list-study/"
            {% elif question.column.title == '交友' %}
                "/blocks/blocks-list-friend/"
            {% endif %}>
                <button type="button"
                    class="btn btn-sm mb-2
                        {% if question.column.title == '生活' %}
                            btn-warning
                        {% elif question.column.title == '学习' %}
                            btn-danger
                        {% elif question.column.title == '交友' %}
                            btn-success
                        {% endif %}
                    "
                >
                    {{ question.column }}
                </button>
            </a>
            {% endif %}
            <!-- 标题 -->
            <h4>
                <b>
                    <a href="{% url 'question:question_detail' question.id %}"
                       style="color: black;"
                    >
                        {{ question.title }}
                    </a>
                </b>
            </h4>
            <!-- 摘要 -->
            <div>
                <p style="color: gray;">
                    {{ question.description|slice:'100' }}...
                </p>
            </div>
            <!-- 注脚 -->
            <p>
                <!-- 附加信息 -->
                <span>
                    <i class="fas fa-user" style="color:yellowgreen"></i>
                    {{ question.author }}
                </span>
                <span>
                    <i class="fas fa-clock" style="color:gray;"></i>
                    {{ question.created|date:'Y-m-d' }}
                </span>
                <span>
                    <i class="fas fa-clock" style="color:pink;"></i>
                    {{ question.updated|date:'Y-m-d' }}
                </span>
                <span>
                    <i class="fas fa-eye" style="color:blueviolet;"></i>
                    {{ question.total_views }}
                </span>
            </p>
            <hr>
        </div>
    {% endfor %}
</div>
<!-- 
片段名称：  显示热门文章
作者:	    qhy
时间：	    2020-8-4
功能：	   显示热门文章，根据热度顺序显示，并根据会显示所属板块，点击可以浏览详情
修改记录： 
--> 
<div class="text-center mt-4">
    <h4><b>热门文章</b></h4>
</div>

<!-- 列表循环 -->
<div class="row ml-5">
    {% for article in articles %}
        <!-- 文章内容 -->
        <div class="col-12">
            <!-- 栏目 -->
            {% if article.column %}
            <a href=
            {% if article.column.title == '生活' %}
                "/blocks/blocks-list-life/"
            {% elif article.column.title == '学习' %}
                "/blocks/blocks-list-study/"
            {% elif article.column.title == '交友' %}
                "/blocks/blocks-list-friend/"
            {% endif %}>
                <button type="button"
                    class="btn btn-sm mb-2
                        {% if article.column.title == '生活' %}
                            btn-warning
                        {% elif article.column.title == '学习' %}
                            btn-danger
                        {% elif article.column.title == '交友' %}
                            btn-success
                        {% endif %}
                    "
                >
                    {{ article.column }}
                </button>
            </a>
            {% endif %}
            <!-- 标题 -->
            <h4>
                <b>
                    <a href="{% url 'article:article_detail' article.id %}"
                       style="color: black;"
                    >
                        {{ article.title }}
                    </a>
                </b>
            </h4>
            <!-- 摘要 -->
            <div>
                <p style="color: gray;">
                    {{ article.body|slice:'100' }}...
                </p>
            </div>
            <!-- 注脚 -->
            <p>
                <!-- 附加信息 -->
                <span>
                    <i class="fas fa-user" style="color:yellowgreen"></i>
                    {{ article.author }}
                </span>
                <span>
                    <i class="fas fa-clock" style="color:gray;"></i>
                    {{ article.created|date:'Y-m-d' }}
                </span>
                <span>
                    <i class="fas fa-clock" style="color:pink;"></i>
                    {{ article.updated|date:'Y-m-d' }}
                </span>
                <span>
                    <i class="fas fa-eye" style="color:blueviolet;"></i>
                    {{ article.total_views }}
                </span>
            </p>
            <hr>
        </div>
    {% endfor %}
</div>

templates/mainPage.html
<!-- extends表明此页面继承自 base.html 文件 -->
{% extends "base.html" %}
{% load staticfiles %}

<!-- 写入 base.html 中定义的 title -->
{% block title %}
    首页
{% endblock title %}
<!-- 
片段名称： 主界面
作者:	    ssc
时间：	    2020-8-4
功能：	   显示主界面，包含了header footer 发布的入口还有热门板块
修改记录： 
--> 
<!-- 写入 base.html 中定义的 content -->
{% block content %}

    <!-- 发布问题,发布文章 -->
    {% include 'uploadButton.html' %}
    <!-- 引入热门内容 -->
    {% include 'hotContent.html' %}
{% if messages %}
<!--信息弹框形式-->
<script>
    {% for msg in messages %}
        alert('{{ msg.message }}');
    {% endfor %}
</script>
{% endif %}
{% endblock content %}

templates/uploadButton.html
<!-- 
片段名称：  发布问题文章的按钮
作者:	    ssc
时间：	    2020-8-3
功能：	   发布问题文章的按钮
修改记录： 
--> 
<div class="container">
        <div class="d-flex justify-content-center">
            <button type="button" class="btn btn-outline-secondary mt-2 mb-2 ml-5 mr-5" ><a href="{% url 'question:question_create'  %}">发布问题</a></button>
            <button type="button" class="btn btn-outline-secondary mt-2 mb-2 ml-5 mr-5" ><a href="{% url 'article:article_create'  %}">发布文章</a></button>
        </div>
</div>